/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the FilesList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FilesList{}

// FilesList struct for FilesList
type FilesList struct {
	Results []File `json:"results"`
	Total int32 `json:"total"`
}

// NewFilesList instantiates a new FilesList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFilesList(results []File, total int32) *FilesList {
	this := FilesList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewFilesListWithDefaults instantiates a new FilesList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFilesListWithDefaults() *FilesList {
	this := FilesList{}
	return &this
}

// GetResults returns the Results field value
func (o *FilesList) GetResults() []File {
	if o == nil {
		var ret []File
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *FilesList) GetResultsOk() ([]File, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *FilesList) SetResults(v []File) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *FilesList) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *FilesList) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *FilesList) SetTotal(v int32) {
	o.Total = v
}

func (o FilesList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FilesList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableFilesList struct {
	value *FilesList
	isSet bool
}

func (v NullableFilesList) Get() *FilesList {
	return v.value
}

func (v *NullableFilesList) Set(val *FilesList) {
	v.value = val
	v.isSet = true
}

func (v NullableFilesList) IsSet() bool {
	return v.isSet
}

func (v *NullableFilesList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFilesList(val *FilesList) *NullableFilesList {
	return &NullableFilesList{value: val, isSet: true}
}

func (v NullableFilesList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFilesList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


